<?php

namespace Misaz\WYSIWYM\Convertors;

use Misaz\WYSIWYM\IConvertor;

/**
 * Convert bolds
 * Class BoldConvertor
 * @package Misaz\WYSIWYM\Convertors
 */
class BoldConvertor implements IConvertor {

	/**
	 * @var string Char sequence expected on input
	 */
	protected $charSequence = "**";

	/**
	 * @var string Tag passed into output
	 */
	protected $htmlTag = "b";

	/**
	 * Convert bolds into html
	 * @param string $input
	 * @return string
	 */
	function convert($input) {
		$output = $input;
		while(strpos($output, $this->charSequence) !== FALSE) {
			$output = preg_replace('/' . preg_quote($this->charSequence) . '/', "<$this->htmlTag>", $output, 1);
			$output = preg_replace('/' . preg_quote($this->charSequence) . '/', "</$this->htmlTag>", $output, 1);
		}
		return $output;
	}

	/**
	 * Return avaible tags required for this convertor
	 * @return array
	 */
	function avaibleTags() {
		return array($this->htmlTag);
	}
}