<?php
/**
 * Created by PhpStorm.
 * User: Michal
 * Date: 3/6/2015
 * Time: 18:34
 */

namespace Misaz\WYSIWYM\Convertors;


use Misaz\WYSIWYM\IConvertor;

/**
 * Convert hyperlinks
 * Class HyperlinkConvertor
 * @package Misaz\WYSIWYM\Convertors
 */
class HyperlinkConvertor implements IConvertor {

	/**
	 * @param string $input
	 * @return string
	 */
	function convert($input) {
		$output = $input;

		// regex for detecting "blablab":blablab syntax
		//                      ^--1--^  ^--2--^
		$regex = '/"([a-zA-Z0-9:\/\.\-]*)":([a-zA-Z0-9]*)/';
		do {
			preg_match($regex, $output, $matches);
			if (isset($matches[1]) && isset($matches[2])) {
				//parse
				$text = $matches[2];
				$href = $matches[1];
				// create output
				$output = preg_replace($regex, '<a href="' . $href . '">' . $text . '</a>', $output, 1, $count);
			}
		} while(count($matches) >= 3);
		return $output;
	}

	/**
	 * Return avaible tags required for this convertor
	 * @return array
	 */
	function avaibleTags() {
		return array("a");
	}
}


