<?php

namespace Misaz\WYSIWYM\Convertors;


use Misaz\WYSIWYM\IConvertor;

/**
 * Conver pictures
 * Class ImageConvertor
 * @package Misaz\WYSIWYM\Convertors
 */
class ImageConvertor implements IConvertor {

	/**
	 * @param string $input
	 * @return string
	 */
	function convert($input) {

		// regex for detecting syntax [* obrazek.jpg .(Obrázek) *]
		//                               ^----1----^   ^--2--^
		$regex = '!\[\* ([a-zA-Z0-9\\\/\.\-]*) \.\(([a-zA-Z0-9 ěščřžýáíéůúóňťďĚŠČŘŽÝÁÍÉŮÚÓŇŤĎ]*)\) \*\]!';

		$output = $input;
		do { // replaces all images
			preg_match($regex, $output, $matches);
			if (isset($matches[1]) && isset($matches[2])) {
				// parse attributes
				$src = $matches[1];
				$alt = $matches[2];
				// create output
				$output = preg_replace($regex, '<img src="' . $src . '" alt="' . $alt . '" />', $output, 1, $count);
			}
		} while(count($matches) >= 3);

		return $output;
	}

	/**
	 * Return avaible tags required for this convertor
	 * @return array
	 */
	function avaibleTags() {
		return array("img");
	}
}