<?php

namespace Misaz\WYSIWYM\Convertors;


use Misaz\WYSIWYM\IConvertor;

/**
 * Conver dash list
 * Class ListConvertor
 * @package Misaz\WYSIWYM\Convertors
 */
class ListConvertor implements IConvertor {

	/**
	 * @param string $input
	 * @return string
	 */
	function convert($input) {
		$output = $input;
		$lines = explode("\n", $output);
		$ol = array();

		for ($i = 0; $i < count($lines); $i++) {
			if (strlen($lines[$i]) > 0 && $lines[$i][0] == '-') { // if line start by dash

				$pl = ($i > 0) ? $ol[count($ol) - 1] : ""; // previous line
				// previous line we need because we must remove end tag and in current line can't insert start tag
				if ($i > 0 && (strpos($pl, "<ul><li>") === 0 || strpos($pl, "<li>") === 0)) { //if previousLine == list
					$pl = substr($pl,0, strlen($pl) - 5); // remove end tag
					$ol[count($ol) - 1] = $pl; // update $pl

					// current line can't have start tag <ul> because continues the same list as previous line
					$ol[] = "<li>" . trim(substr($lines[$i], 1, strlen($lines[$i]) - 1)) . "</li></ul>";
				} else {
					// new list
					$ol[] = "<ul><li>" . trim(substr($lines[$i], 1, strlen($lines[$i]) - 1)) . "</li></ul>";
				}

			} else if (strlen($lines[$i]) > 0) { // include non-list line
				$ol[] = $lines[$i];
			}
		}

		return implode("\n", $ol);
	}

	/**
	 * Return avaible tags required for this convertor
	 * @return array
	 */
	function avaibleTags() {
		return array("ul", "li");
	}
}