<?php

namespace Misaz\WYSIWYM\Convertors;


use Misaz\WYSIWYM\IConvertor;

class ParagraphConvertor implements IConvertor {

	protected $htmlTag = "p";

	public $avaibleTags = array();

	/**
	 * Convert paragraphs and check XSS
	 * @param string $input
	 * @return string
	 */
	function convert($input) {
		$lines = explode("\n", $input);
		$output = array();
		for($i = 0; $i < count($lines); $i++) {
			// empty line
			if (strlen($lines[$i]) == 0) {
				continue;
			}

			if ($lines[$i][0] != '<') { // don't start by tag
				$output[] = "<$this->htmlTag>" . htmlentities($lines[$i]) . "</$this->htmlTag>";
			} else { // start by tag
				// regex for getting tag name
				preg_match('!<([a-zA-Z0-9]*)!', $lines[$i], $matches);
				$tag = trim(strtolower($matches[1])); //parse tag
				if (array_search($tag, $this->avaibleTags) !== false) { // check if tag is on whitelist
					$output[] = $lines[$i]; // if yes, append line
				} else {
					$output[] = htmlentities($lines[$i]); // if not, un-XSS and append
				}
			}
		}
		return implode("\n", $output);
	}

	/**
	 * Return avaible tags required for this convertor
	 * @return array
	 */
	function avaibleTags() {
		return array($this->htmlTag);
	}
}