<?php

namespace Misaz\WYSIWYM\Convertors;


use Misaz\WYSIWYM\IConvertor;

/**
 * Convert title on main (first) layer
 * Class Title1Convertor
 * @package Misaz\WYSIWYM\Convertors
 */
class Title1Convertor implements IConvertor {
	/**
	 * @var string Cahr sequnce expected in input
	 */
	protected $charSequence = "#";

	/**
	 * @var string Output tag
	 */
	protected $htmlTag = "h1";

	/**
	 * @param string $input
	 * @return string
	 */
	function convert($input) {
		$output = $input;
		$lines = explode("\n", $output);

		for ($i = 0; $i < count($lines); $i++) {
			$title = false;
			// check if all chars on line are $charSequence
			for ($j = 0; $j < strlen($lines[$i]); $j++) {
				if ($lines[$i][$j] == $this->charSequence) {
					$title = true;
				} else {
					$title = false;
					break;
				}
			}
			if ($title) {
				// fine before $charSequence will be pasked into title element
				$lines[$i - 1] = "<$this->htmlTag>" . $lines[$i - 1] . "</$this->htmlTag>";
				$lines[$i] = ""; // current line (line with $charSequence) will empty
			}
		}

		$output = implode("\n", $lines);
		return $output;
	}

	/**
	 * Return avaible tags required for this convertor
	 * @return array
	 */
	function avaibleTags() {
		return array($this->htmlTag);
	}
}