<?php

class Premena
{
    
    /**
     * @param @string $text Text zadaný uživatelem
     * @return @string Výsledný text
     */
    public function vrat($text)
    {
        $vysledek = $text;
        
        // Obrázek (kvůli kurzíve na začátku)
        $vysledek = preg_replace('/\[\* (.*) \<\((.*)\) \*\]/', '<img src="$1" alt="$2" align="left" />', $vysledek);
        $vysledek = preg_replace('/\[\* (.*) \.\((.*)\) \*\]/', '<div class="obrazek"><img src="$1" alt="$2" /></div>', $vysledek);
        $vysledek = preg_replace('/\[\* (.*) \>\((.*)\) \*\]/', '<img src="$1" alt="$2" align="right" />', $vysledek);
        
        // Velký nadpis
        $vysledek = preg_replace('/(.*?)\n#####.*/', '<h1>$1</h1>', $vysledek);
        // Nadpis o úrovni <h2>
        $vysledek = preg_replace('/(.*?)\n=====.*/', '<h2>$1</h2>', $vysledek);
        // Tučný text
        $vysledek = preg_replace('/\*\*(.*?)\*\*/', '<strong>$1</strong>', $vysledek);
        // Kurzíva
        $vysledek = preg_replace('/\*(.*?)\*/', '<em>$1</em>', $vysledek);
        // Podtrhnutí
        $vysledek = preg_replace('/\n----------.*/', '<hr />', $vysledek);
        // Odkaz
        $vysledek = preg_replace('/"(http:\/\/[a-zA-Z0-9-\/.]*)":([a-zA-Z0-9]*)/', '<a href="$1">$2</a>', $vysledek);

        // Seznam
        $vysledek = preg_replace('/\n- (.*)?/', '<li>$1</li>', $vysledek);
        $vysledek = preg_replace('/(<li>.*<\/li>)/', "\n<ul>$1", $vysledek);
        $vysledek = preg_replace('/(<li>.*<\/li>\n)/', '$1</ul>', $vysledek);
        
        // Text
        $vysledek = $this->odstavec($vysledek);
        
        return $vysledek;
    }
    
    /**
     * @param @string $text Text již zpracovaný vším
     * @return @string Text v odstavcích
     */
    private function odstavec($text)
    {
        // Zjištění, zda je další řádek prázdný nebo ne
        $prazdno = 0;
        $radky = explode("\n", $text);
        
        for($i = 0; $i < count($radky); $i++)
        {
            if($radky[$i][0] != '<')
            {
                if(strlen($radky[$i + 1]) <= 1)
                {
                    // První řádek s textem
                    $aktualne = $i - $prazdno;
                    $radky[$aktualne] = "<p>" . $radky[$aktualne];
                    
                    for(; $prazdno > 0;)
                    {
                        $prazdno--;
                        $radky[$aktualne] .= $radky[$i - $prazdno];
                        unset($radky[$i - $prazdno]);
                    }
                    
                    $prazdno = 0;
                    $radky[$aktualne] .= "</p>";
                }
                else
                    $prazdno++;
            }
        }
        
        $vysledek = implode("\n", $radky);
        return $vysledek;
    }
    
}