<?php

namespace app;

use app\Convertors\Bold;
use app\Convertors\Header1;
use app\Convertors\Header2;
use app\Convertors\Header3;
use app\Convertors\Header4;
use app\Convertors\Header5;
use app\Convertors\Header6;
use app\Convertors\Image;
use app\Convertors\Italic;
use app\Convertors\Link;
use app\Convertors\Paragraph;
use app\Convertors\UnorderedList;

/**
* WYSIWYM convertor
*/
class WYSIWYM
{
	/**
	* @var string obsah
	*/
	private $output;

	function __construct($content)
	{
		$this->convert($content);
	}

	private function convert($content)
	{
		$bold = new Bold();
		$italic = new Italic();
		$h1 = new Header1();
		$h2 = new Header2();
		$h3 = new Header3();
		$h4 = new Header4();
		$h5 = new Header5();
		$h6 = new Header6();
		$img = new Image();
		$link = new Link();
		$ul = new UnorderedList();
		$p = new Paragraph();
		$this->output = $img->convert($content);
		$this->output = $link->convert($this->output);
		$this->output = $ul->convert($this->output);
		$this->output = $h6->convert($this->output);
		$this->output = $h5->convert($this->output);
		$this->output = $h4->convert($this->output);
		$this->output = $h3->convert($this->output);
		$this->output = $h2->convert($this->output);
		$this->output = $h1->convert($this->output);	
		$this->output = $bold->convert($this->output);
		$this->output = $italic->convert($this->output);
		$this->output = $p->convert($this->output);
	}

	public function getHTML()
	{
		return $this->output;
	}
}